#TouhouDanmakufu[Plural]
#ScriptVersion[3]
#Title["Achy's Popular Popularity Marisa"]
#text["A Marisa Boss Battle made by Achy for RaNGE Contest # 14"]

let SoundEffect = [];
let SoundEffectStr = [];
let ImageStars = GetCurrentScriptDirectory ~ "IMG/Cosmos.png";
CreateObjectSound("se_shot_tan00");
CreateObjectSound("se_shot_tan01");
CreateObjectSound("se_shot_laser");
CreateObjectSound("se_shot_kira00");
CreateObjectSound("se_boss_call");
CreateObjectSound("se_player_bomb");
CreateObjectSound("se_effect_glub");
CreateObjectSound("se_shot_tan02");
CreateObjectSound("se_effect_weird2");
SetCommonData("MarisaBossPlural.cs",GetOwnScriptID);
let BGM = ObjSound_Create;
ObjSound_Load(BGM,GetCurrentScriptDirectory ~ "SFXandBGM/DemetoriFinalSorcery.ogg");
ObjSound_SetLoopEnable(BGM,true);
ObjSound_Play(BGM);
let vol = 60;
ObjSound_SetVolumeRate(BGM,vol);
ObjSound_SetLoopTime(BGM,20,14400);


@Initialize
{
	MarisaPlural();
	Background;
	SetPlayerLife(99);
}

@MainLoop
{
	yield;
}

@Event{
 alternative(GetEventType)
 case(EV_USER+20){PlaySound(GetEventArgument(0));}
}

@Finalize
{
}

task CreateObjectSound(name){ //Thanks to GTbot
 let objSound = ObjSound_Create;
 ObjSound_Load(objSound, GetCurrentScriptDirectory~"SFXandBGM/"~name~".wav");
 ObjSound_SetSoundDivision(objSound, SOUND_SE);
 ObjSound_SetRestartEnable(objSound, true);
 SoundEffect = SoundEffect~[objSound];
 SoundEffectStr = SoundEffectStr~[name];
}

task PlaySound(name){
 let ID = -1;
 ascent(i in 0..length(SoundEffectStr)){
  if(SoundEffectStr[i]==name){ID = i; break;}
 }
 if(ID==-1){RaiseError("Error when attempting to play audio: "~name~" (Not Found)");}
 ObjSound_Play(SoundEffect[ID]);
}

task Background {
	let BGobj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetTexture(BGobj,ImageStars);
	ObjSprite2D_SetSourceRect(BGobj,0,0,800,800);
	ObjSprite2D_SetDestRect(BGobj,0,0,GetStgFrameWidth,GetStgFrameHeight);
	Obj_SetRenderPriorityI(BGobj,21);
	ObjSprite2D_SetDestCenter(BGobj); 
	let count = 0;
	loop {
		count+=0.2;
		ObjRender_SetPosition(BGobj,GetStgFrameWidth/2+130*cos(count),GetStgFrameHeight/2+130*sin(count),0);
		yield;
		if (count == 360) {count = 0;  }
	}
}

task MarisaPlural {
	let direct = GetCurrentScriptDirectory();
	let Bossscene = ObjEnemyBossScene_Create();
	ObjEnemyBossScene_Add(Bossscene, 0, direct ~ "MarisaNon1.cs");
	ObjEnemyBossScene_Add(Bossscene, 0, direct ~ "MarisaSpell1.cs");
	ObjEnemyBossScene_Add(Bossscene, 1, direct ~ "MarisaNon2.cs");
	ObjEnemyBossScene_Add(Bossscene, 1, direct ~ "MarisaSpell2.cs");
	ObjEnemyBossScene_Add(Bossscene, 2, direct ~ "MarisaNon4.cs");
	ObjEnemyBossScene_Add(Bossscene, 2, direct ~ "MarisaSpell3.cs");
	ObjEnemyBossScene_LoadInThread(Bossscene);
	ObjEnemyBossScene_Regist(Bossscene);


	while(!Obj_IsDeleted(Bossscene)) {
		yield;
	}
	loop(vol) {
		vol--;
		ObjSound_SetVolumeRate(BGM,vol);
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);
		yield;
	}
	CloseScript(GetOwnScriptID());
}